UlduarAutoPilot = LibStub("AceAddon-3.0"):NewAddon("UlduarAutoPilot", "AceConsole-3.0", "AceEvent-3.0")
local addon = UlduarAutoPilot
local callbacks = LibStub("CallbackHandler-1.0"):New(UlduarAutoPilot)

UlduarAutoPilot.subzones = {
	["Expedition Base Camp"] = 1,			--Home
	["Iron Concourse"] = 2,					--Flame Leviathan
	["Formation Grounds"] = 2,				--Flame Leviathan
	["The Colossal Forge"] = 3,				--Ignis the Furnace Master
	["Razorscale's Aerie"] = 3,				--Razorscale
	["The Scrapyard"] = 3,					--XT-002 Deconstructor
	["The Antechamber"] = 5,				--trash before Kologarn and Assembly of Iron
	["The Assembly of Iron"] = 5,			--Ferrous Collaborative
	["The Celestial Planetarium"] = 5,		--Algalon
	["The Shattered Walkway"] = 6,			--Kologarn
	["The Observation Ring"] = 6,			--Auriaya
	["Halls of Winter"] = 6,				--Hodir
	["The Clash of Thunder"] = 7,			--Thorim
	["The Conservatory of Life"] = 7,		--Freya
	["The Corridors of Ingenuity"] = 7,		--trash before Mimiron
	["LMS Mark II"] = 7,					--please keep your seatback and tray table in its full upright and locked position while the train is in motion
	["The Spark of Imagination"] = 8,		--Mimiron
	["Hall of Memories"] = 6,				--trash before General Vezax
	["The Descent into Madness"] = 6,		--General Vezax
	["The Prison of Yogg-Saron"] = 9,  		--Possibility for anal tentacle rape = high
}

UlduarAutoPilot.teleports = {
	[1] = "Expedition Base Camp",
	[2] = "Formation Grounds",
	[3] = "Colossal Forge",
	[4] = "Scrapyard", 						--most worthless teleport location ever
	[5] = "Antechamber of Ulduar",
	[6] = "The Shattered Walkway",
	[7] = "Conservatory of Life",
	[8] = "Spark of Imagination",
	[9] = "Descent Into Madness",
	[99] = "(none selected)",				--"nil" location
}

local function triggerEvent(...)
	callbacks:Fire(...)
end

function UlduarAutoPilot:OnInitialize()
	self.teleportlocation = 99
end

function UlduarAutoPilot:OnEnable()
	self:RegisterEvent("PLAYER_DEAD", function() self:SetTeleportLocation(GetSubZoneText()) end)
	self:RegisterEvent("GOSSIP_SHOW", "SelectTeleportGossip")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	
	--[[ debug ]]--
	self:RegisterChatCommand("uapget", function() self:Print("Teleport set to " .. self.teleports[self.teleportlocation]) end)
	self:RegisterChatCommand("uapset", function() self:Print("Setting location to ".. self.teleports[self.subzones[GetSubZoneText()]]);self:SetTeleportLocation(GetSubZoneText()) end)
	self:RegisterChatCommand("uapclear", function() self.teleportlocation = 99 end)
end

function UlduarAutoPilot:SetTeleportLocation(loc)
	if not GetRealZoneText():find("Ulduar") then return end
	if type(loc) == "number" then
		self.teleportlocation = loc --called from LDB, we already know the index
	else
		self.teleportlocation = self.subzones[loc] --called from PLAYER_DEATH, find the teleporter
	end
	triggerEvent("UpdateDestination")
end

function UlduarAutoPilot:SelectTeleportGossip()
	if not GetRealZoneText():find("Ulduar") or IsAltKeyDown() or self.teleportlocation == 99 then return end
	if GetSubZoneText() == "Expedition Base Camp" then SelectGossipOption(self.teleportlocation) end
end

function UlduarAutoPilot:ZONE_CHANGED_NEW_AREA()
	if GetRealZoneText():find("Ulduar") and self.teleportlocation < 99 then
		self:Print("The Base Camp teleport will automatically send you to " .. self.teleports[self.teleportlocation] .. ". Use Alt-click to override.")
	end
end