﻿local UlduarAutoPilot = UlduarAutoPilot

if not LibStub then return end
local ldb = LibStub:GetLibrary("LibDataBroker-1.1", true)
if not ldb then return end

UAPLDB = ldb:NewDataObject("UlduarAutoPilot", {
	type = "data source",
	text = "UlduarAutoPilot",
	icon = "Interface\\Icons\\achievement_boss_yoggsaron_01",
})
local UAPLDB = UAPLDB
local callbacks = LibStub("CallbackHandler-1.0"):New(UAPLDB)

local menu = {}
do
	for k,v in ipairs(UlduarAutoPilot.teleports) do
		local x = {
			text = v,
			func = function()
				UlduarAutoPilot:SetTeleportLocation(k)
			end,
		}
		table.insert(menu, x)
	end
end

local popupFrame = CreateFrame("Frame", "UlduarAutoPilotMenu", UIParent, "UIDropDownMenuTemplate")
function UAPLDB.OnClick(self, button)
	EasyMenu(menu, popupFrame, self, 20, 4, "MENU")
end

local function updateDisplay()
	UAPLDB.text = UlduarAutoPilot.teleports[UlduarAutoPilot.teleportlocation] or "UlduarAutoPilot"
end

UlduarAutoPilot.RegisterCallback(UAPLDB, "UpdateDestination", updateDisplay)
